> ## Documentation Index
> Fetch the complete documentation index at: https://www.canva.dev/docs/apps/llms.txt
> Use this file to discover all available pages before exploring further.
# Get image generation job
This API is currently provided as a preview. Be aware of the following:
* There might be unannounced breaking changes.
* Any breaking changes to preview APIs won't produce a new [API version](https://www.canva.dev/docs/apps/rest-apis/versions/).
* Public apps that use preview APIs will not pass the review process, and can't be made available to all Canva users.
Gets the result of an image generation job that was created using the [Create image generation job API](https://www.canva.dev/docs/apps/rest-apis/reference/generations/create-image-generation-job/). Only the app and user that created the job can get it.
If the job is successful, the job's `result` contains a download URL for the generated image. The download URL is only valid for 24 hours. If the job was created with `asset_upload` set to `type: upload`, the `result` also contains the image asset that the image was saved as. These jobs stay `in_progress` until the asset has finished importing, so the returned asset is ready to use.
You might need to make multiple requests to this endpoint until you get a `success` or `failed` status. For more information on the workflow for using asynchronous jobs, see [API requests and responses](https://www.canva.dev/docs/apps/rest-apis/requests-responses/#asynchronous-job-endpoints).
## HTTP method and URL path
GET https\://api.canva.com/rest/v1/image-generations/\{jobId}
### Rate limit
This operation's rate limit depends on your app type:
| App type |
Rate limit |
| **Public or private apps** (acts on behalf of a user using the OAuth authorization code flow) |
120 requests per minute for each user of your app |
| **Service apps** (acts on behalf of your app itself using the OAuth client credentials flow) |
1000 requests per minute for your app |
## Authentication and authorization
This endpoint requires a valid OAuth access token. For more information, see [Generate an access token](/docs/apps/rest-apis/reference/authentication/generate-access-token).
### Scopes
The access token must have the following [scopes](/docs/apps/rest-apis/scopes) (permissions), depending on your app type:
| App type |
Required scopes |
| **Public or private apps** (acts on behalf of a user using the OAuth authorization code flow) |
* `asset:write`
|
| **Service apps** (acts on behalf of your app itself using the OAuth client credentials flow) |
* `service:asset:write`
|
### Capabilities
Capabilities only apply to public or private apps, which act on behalf of a user. The user must have at least one of the following [capabilities](/docs/apps/rest-apis/capabilities/):
* `image_generation`
## Header parameters
Provides credentials to authenticate the request, in the form of a `Bearer` token.
For example: `Authorization: Bearer {token}`
## Path parameters
The image generation job ID.
## Example request
Examples for using the `/v1/image-generations/{jobId}` endpoint:
```sh
curl --request GET 'https://api.canva.com/rest/v1/image-generations/{jobId}' \
--header 'Authorization: Bearer {token}'
```
```js
const fetch = require("node-fetch");
fetch("https://api.canva.com/rest/v1/image-generations/{jobId}", {
method: "GET",
headers: {
"Authorization": "Bearer {token}",
},
})
.then(async (response) => {
const data = await response.json();
console.log(data);
})
.catch(err => console.error(err));
```
```java
import java.io.IOException;
import java.net.URI;
import java.net.http.*;
public class ApiExample {
public static void main(String[] args) throws IOException, InterruptedException {
HttpRequest request = HttpRequest.newBuilder()
.uri(URI.create("https://api.canva.com/rest/v1/image-generations/{jobId}"))
.header("Authorization", "Bearer {token}")
.method("GET", HttpRequest.BodyPublishers.noBody())
.build();
HttpResponse response = HttpClient.newHttpClient().send(
request,
HttpResponse.BodyHandlers.ofString()
);
System.out.println(response.body());
}
}
```
```py
import requests
headers = {
"Authorization": "Bearer {token}"
}
response = requests.get("https://api.canva.com/rest/v1/image-generations/{jobId}",
headers=headers
)
print(response.json())
```
```csharp
using System.Net.Http;
var client = new HttpClient();
var request = new HttpRequestMessage
{
Method = HttpMethod.Get,
RequestUri = new Uri("https://api.canva.com/rest/v1/image-generations/{jobId}"),
Headers =
{
{ "Authorization", "Bearer {token}" },
},
};
using (var response = await client.SendAsync(request))
{
response.EnsureSuccessStatusCode();
var body = await response.Content.ReadAsStringAsync();
Console.WriteLine(body);
};
```
```go
package main
import (
"fmt"
"io"
"net/http"
)
func main() {
url := "https://api.canva.com/rest/v1/image-generations/{jobId}"
req, _ := http.NewRequest("GET", url, nil)
req.Header.Add("Authorization", "Bearer {token}")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}
```
```php
$curl = curl_init();
curl_setopt_array($curl, array(
CURLOPT_URL => "https://api.canva.com/rest/v1/image-generations/{jobId}",
CURLOPT_CUSTOMREQUEST => "GET",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_HTTPHEADER => array(
'Authorization: Bearer {token}',
),
));
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if (empty($err)) {
echo $response;
} else {
echo "Error: " . $err;
}
```
```ruby
require 'net/http'
require 'uri'
url = URI('https://api.canva.com/rest/v1/image-generations/{jobId}')
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Get.new(url)
request['Authorization'] = 'Bearer {token}'
response = http.request(request)
puts response.read_body
```
## Success response
If successful, the endpoint returns a `200` response with a JSON body with the following parameters:
Details about the image generation job. If the job status is `success`, the job's
`result` is present.
Properties of job>} defaultExpanded={true}>
The image generation job ID.
The status of the image generation job. A newly created job will be `in_progress` and
will eventually become `success` or `failed`. If the status is `success`, the job's
`result` is present.
**Available values:**
* `failed`
* `in_progress`
* `success`
Result of the image generation job. Only present if job status is `success`.
Properties of result>}>
A generated image.
Properties of image>}>
A download URL for the generated image. The download URL is only valid for 24
hours.
The width of the generated image in pixels.
The height of the generated image in pixels.
The image asset the generated image was saved as. Only present if the job was created
with `asset_upload` set to `type: upload` and the asset still exists (for example, it's
absent if the user has since deleted the asset).
Properties of asset>}>
Type of an asset.
**Available values:**
* `image`
* `video`
The ID of the asset.
The name of the asset.
The user-facing tags attached to the asset.
Users can add these tags to their uploaded assets, and they can search their uploaded
assets in the Canva UI by searching for these tags. For information on how users use
tags, see the
[Canva Help Center page on asset tags](https://www.canva.com/help/add-edit-tags/).
When the asset was added to Canva, as a Unix timestamp (in seconds since the Unix
Epoch).
When the asset was last updated in Canva, as a Unix timestamp (in seconds since the
Unix Epoch).
A thumbnail image representing the object.
Properties of thumbnail>}>
The width of the thumbnail image in pixels.
The height of the thumbnail image in pixels.
A URL for retrieving the thumbnail image.
This URL expires after 15 minutes. This URL includes a query string
that's required for retrieving the thumbnail.
If the image generation job fails, this object provides details about the error. Only present if status is `failed`.
Properties of error>}>
Error code indicating what went wrong with the image generation.
**Available values:**
* `unsafe_input`: Content safety checks rejected the prompt.
* `timeout`: The generation did not complete in time.
* `model_not_available`: The requested model can't currently serve this request, and Canva doesn't retry the job
with another model. This is usually temporary. Retry later, retry without the `model`
parameter to use automatic model selection, or retry with a different model.
* `model_retired`: The requested model has been permanently retired from this version of the API, and you
can't use it again in this version. Use a different model. The API documentation lists
retired models, which keep their enum value for the lifetime of this API version.
* `internal_error`: An unexpected error occurred during generation.
A human-readable description of what went wrong.
## Example response
```json
{
"job": {
"id": "string",
"status": "failed",
"result": {
"image": {
"url": "string",
"asset": {
"type": "image",
"id": "Msd59349ff",
"name": "My Awesome Upload",
"tags": [
"image",
"holiday",
"best day ever"
],
"created_at": 1377396000,
"updated_at": 1692928800,
"thumbnail": {
"width": 595,
"height": 335,
"url": "https://document-export.canva.com/Vczz9/zF9vzVtdADc/2/thumbnail/0001.png?"
}
},
"width": 1024,
"height": 1024
}
},
"error": {
"code": "unsafe_input",
"message": "string"
}
}
}
```
## Error responses
### 401 Unauthorized
A short string indicating what failed. This field can be used to handle errors programmatically. For a complete list of error codes, see [Error responses](/docs/apps/rest-apis/error-responses/).
A human-readable description of what went wrong.
#### Example error responses
##### The OAuth client credentials are invalid
```json
{
"code": "invalid_client",
"message": "Client {clientId} not available"
}
```
##### Access token could not be decoded or signature could not be verified.
```json
{
"code": "invalid_access_token",
"message": "Access token is invalid"
}
```
##### Client credentials or body auth are missing from the request
```json
{
"code": "invalid_client",
"message": "Client credentials or body auth are missing from the request."
}
```
##### Authorization header has wrong number of components
```json
{
"code": "invalid_access_token",
"message": "Malformed Authorization header: wrong number of components"
}
```
##### Authorization header has invalid mode
```json
{
"code": "invalid_access_token",
"message": "Malformed Authorization header: invalid mode"
}
```
##### Token couldn't be introspected
```json
{
"code": "invalid_access_token",
"message": "Token couldn't be introspected"
}
```
##### Access token is revoked
```json
{
"code": "revoked_access_token",
"message": "Access token is revoked"
}
```
##### Missing Authorization header
```json
{
"code": "invalid_access_token",
"message": "Missing Authorization header"
}
```
##### Malformed Authorization header
```json
{
"code": "invalid_access_token",
"message": "Malformed Authorization header"
}
```
### 403 Forbidden
A short string indicating what failed. This field can be used to handle errors programmatically. For a complete list of error codes, see [Error responses](/docs/apps/rest-apis/error-responses/).
A human-readable description of what went wrong.
#### Example error responses
##### The required OAuth scope is missing
```json
{
"code": "missing_scope",
"message": "Missing scopes: {scopes}"
}
```
##### Request must be made on behalf of a user
```json
{
"code": "user_role_required",
"message": "This request must be made on behalf of a user."
}
```
##### Not allowed to access the integration
```json
{
"code": "permission_denied",
"message": "Not allowed to access integration with client id {clientId}"
}
```
### 404 Not Found
A short string indicating what failed. This field can be used to handle errors programmatically. For a complete list of error codes, see [Error responses](/docs/apps/rest-apis/error-responses/).
A human-readable description of what went wrong.
#### Example error response
##### The image generation job was not found
```json
{
"code": "not_found",
"message": "Image generation job not found: {jobId}"
}
```
### 429 Too Many Requests
A short string indicating what failed. This field can be used to handle errors programmatically. For a complete list of error codes, see [Error responses](/docs/apps/rest-apis/error-responses/).
A human-readable description of what went wrong.
#### Example error responses
##### Rate limit exceeded
```json
{
"code": "too_many_requests",
"message": "Too many requests to {operation}"
}
```
##### Throttled because too many requests
```json
{
"code": "too_many_requests",
"message": "Throttled because too many requests"
}
```